// SPDX-License-Identifier: Apache-2.0
import { createMock } from "@golevelup/ts-jest";
import { ErrorMsgFixture, EvmAddressPropsFixture, TransactionIdFixture } from "../../../../../../../__tests__/fixtures/shared/DataFixture";
import EvmAddress from "../../../../../../domain/context/contract/EvmAddress";
import { ErrorCode } from "../../../../../../core/error/BaseError";
import { RemoveFromControlListCommandHandler } from "./RemoveFromControlListCommandHandler";
import { RemoveFromControlListCommandResponse } from "./RemoveFromControlListCommand";
import { RemoveFromControlListCommandError } from "./error/RemoveFromControlListCommandError";
import { AddToControlListCommandFixture } from "../../../../../../../__tests__/fixtures/controlList/ControlListFixture";
describe("RemoveFromControlListCommandHandler", () => {
    let handler;
    let command;
    const transactionServiceMock = createMock();
    const validationServiceMock = createMock();
    const accountServiceMock = createMock();
    const contractServiceMock = createMock();
    const evmAddress = new EvmAddress(EvmAddressPropsFixture.create().value);
    const transactionId = TransactionIdFixture.create().id;
    const errorMsg = ErrorMsgFixture.create().msg;
    beforeEach(() => {
        handler = new RemoveFromControlListCommandHandler(accountServiceMock, transactionServiceMock, validationServiceMock, contractServiceMock);
        command = AddToControlListCommandFixture.create();
    });
    afterEach(() => {
        jest.resetAllMocks();
    });
    describe("execute", () => {
        describe("error cases", () => {
            it("throws RemoveFromControlListCommandError when command fails with uncaught error", async () => {
                const fakeError = new Error(errorMsg);
                contractServiceMock.getContractEvmAddress.mockRejectedValue(fakeError);
                const resultPromise = handler.execute(command);
                await expect(resultPromise).rejects.toBeInstanceOf(RemoveFromControlListCommandError);
                await expect(resultPromise).rejects.toMatchObject({
                    message: expect.stringContaining(`An error occurred while removing user from control list: ${errorMsg}`),
                    errorCode: ErrorCode.UncaughtCommandError,
                });
            });
        });
        describe("success cases", () => {
            it("should successfully add to control list", async () => {
                contractServiceMock.getContractEvmAddress.mockResolvedValue(evmAddress);
                accountServiceMock.getAccountEvmAddress.mockResolvedValue(evmAddress);
                transactionServiceMock.getHandler().removeFromControlList.mockResolvedValue({
                    id: transactionId,
                });
                const result = await handler.execute(command);
                expect(result).toBeInstanceOf(RemoveFromControlListCommandResponse);
                expect(result.payload).toBe(true);
                expect(result.transactionId).toBe(transactionId);
                expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledTimes(1);
                expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledWith(command.securityId);
                expect(accountServiceMock.getAccountEvmAddress).toHaveBeenCalledTimes(1);
                expect(accountServiceMock.getAccountEvmAddress).toHaveBeenCalledWith(command.targetId);
                expect(validationServiceMock.checkPause).toHaveBeenCalledWith(command.securityId);
                expect(transactionServiceMock.getHandler().removeFromControlList).toHaveBeenCalledTimes(1);
                expect(transactionServiceMock.getHandler().removeFromControlList).toHaveBeenCalledWith(evmAddress, evmAddress, command.securityId);
            });
        });
    });
});
